'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MemoizeContext = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Memoizer = require('./Memoizer');

var _Memoizer2 = _interopRequireDefault(_Memoizer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var MemoizeContext = function MemoizeContext(_ref) {
  var Consumer = _ref.consumer,
      selector = _ref.selector,
      pure = _ref.pure,
      children = _ref.children,
      rest = _objectWithoutProperties(_ref, ['consumer', 'selector', 'pure', 'children']);

  return _react2.default.createElement(
    Consumer,
    rest,
    function (values) {
      return _react2.default.createElement(
        _Memoizer2.default,
        _extends({}, values, { compute: selector, pure: pure }),
        function (result) {
          return children(result);
        }
      );
    }
  );
};

exports.MemoizeContext = MemoizeContext;
MemoizeContext.propTypes = {
  children: _propTypes2.default.func.isRequired,
  selector: _propTypes2.default.func.isRequired,
  consumer: _propTypes2.default.any.isRequired,
  pure: _propTypes2.default.bool
};

MemoizeContext.defaultProps = {
  pure: true
};