'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MemoizedFlow = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _memoizeState = require('memoize-state');

var _memoizeState2 = _interopRequireDefault(_memoizeState);

var _reactLifecyclesCompat = require('react-lifecycles-compat');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var genFlow = function genFlow(flow) {
  return flow.map(function (fn) {
    return (0, _memoizeState2.default)(fn);
  });
};

var MemoizedFlow = exports.MemoizedFlow = function (_React$Component) {
  _inherits(MemoizedFlow, _React$Component);

  function MemoizedFlow() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, MemoizedFlow);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = MemoizedFlow.__proto__ || Object.getPrototypeOf(MemoizedFlow)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      // eslint-disable-next-line react/no-unused-state
      flow: genFlow(_this.props.flow)
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(MemoizedFlow, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return !this.props.pure || nextState.value !== this.state.value;
    }
  }, {
    key: 'render',
    value: function render() {
      return this.props.children(this.state.value);
    }
  }], [{
    key: 'getDerivedStateFromProps',
    value: function getDerivedStateFromProps(props, state) {
      return {
        value: state.flow.reduce(function (value, fn) {
          return Object.assign({}, value, fn(value));
        }, props.input)
      };
    }
  }]);

  return MemoizedFlow;
}(_react2.default.Component);

MemoizedFlow.propTypes = {
  /* eslint-disable */
  input: _propTypes2.default.object.isRequired,
  /* eslint-enable */
  flow: _propTypes2.default.arrayOf(_propTypes2.default.func).isRequired,
  children: _propTypes2.default.func.isRequired,

  pure: _propTypes2.default.bool
};
MemoizedFlow.defaultProps = {
  pure: false
};


(0, _reactLifecyclesCompat.polyfill)(MemoizedFlow);